
/* step1 build an auxiliary dataset with 2^14 records for all possible permutations */

%let term_rate=LALALA;
/* the macro variables &term_rate. must be defined prior to all of what's below */

data auxdata;
	length ind1 8. ind2 $14. v1 $40. v2 $40. v3 $40. v4 $40. v5 $40. v6 $40. v7 $40. v8 $40. v9 $40. v10 $40.
			v11 $40. v12 $40. v13 $40. v14 $40.;
	do i1 = 0 to 1;
	  if i1=1 then v1="B1*dif_10YrTr_up+"; else v1="";
  	  do i2 = 0 to 1;
	    if i2=1 then v2="B2*dif_10YrTr_down+"; else v2="";
	    do i3 = 0 to 1;
		  if i3=1 then v3="B3*lag_dif_10YrTr_up+"; else v3="";
	      do i4 = 0 to 1;
		    if i4=1 then v4="B4*lag_dif_10YrTr_down+"; else v4="";
	        do i5 = 0 to 1;
			if i5=1 then v5="B5*dif_3MoTr_up+"; else v5="";
	          do i6 = 0 to 1;
			    if i6=1 then v6="B6*dif_3MoTr_up+"; else v6="";
	            do i7 = 0 to 1;
				  if i7=1 then v7="B7*lag_dif_3moTr_up+"; else v7="";
	              do i8 = 0 to 1;
				    if i8=1 then v8="B8*lag_dif_3moTr_down+"; else v8="";
	                do i9 = 0 to 1;
					  if i9=1 then v9="+A1*lag_MoTr"; else v9="";
	                  do i10 = 0 to 1;
					    if i10=1 then v10="+A2*lag_10YrTr"; else v10="";
	                    do i11 = 0 to 1;
						  if i11=1 then v11="+A3*(lag_3MoTr*lag_3MoTr)"; else v11="";
	                      do i12 = 0 to 1;
						    if i12=1 then v12="+A4*(lag_10YrTr*lag_10YrTr)"; else v12="";
	                        do i13 = 0 to 1;
							  if i13=1 then v13="+A5*(lag_3MoTr*lag_3MoTr*lag_3MoTr)"; else v13="";
	                          do i14 = 0 to 1;
								if i14=1 then v14="+A6*(lag_10YrTr*lag_10YrTr*lag_10YrTr)"; else v14="";
								ind1=i1+i2+i3+i4+i5+i6+i7+i8+i9+i10+i11+i12+i13+i14; /* used to index created datasets - number of variables included */
								ind2=put(i1,$1.)||put(i2,$1.)||put(i3,$1.)||put(i4,$1.)||put(i5,$1.)||put(i6,$1.)||put(i7,$1.)||put(i8,$1.)||put(i9,$1.)||put(i10,$1.)||put(i11,$1.)||put(i12,$1.)||put(i13,$1.)||put(i14,$1.); /*used to index datasets. It's the index of what all variables are included in the order that they appear (B1,...A6)*/
								output;
							  end;
							end;	
						  end;	
						end;	
					  end;	
					end;	
				  end;	
				end;	
			  end;
			end;
		  end;
		end;
	  end;	
	end;
run;
/* aggregate V1-V8 in a single var and v9-v14 in another */
data auxdata;
	set auxdata;
	length bvars $400. avars$300;
	bvars = trim(v1)||trim(v2)||trim(v3)||trim(v4)||trim(v5)||trim(v6)||trim(v7)||trim(v8);
	avars = trim(v9)||trim(v10)||trim(v11)||trim(v12)||trim(v13)||trim(v14);
run;


/* step2 read all in appropriate macro variables via proc sql */
proc sql noprint;
	select ind1, ind2, bvars, avars
	into :ind1_1-:ind1_999999,
		 :ind2_1-:ind2_999999,
		 :bvars1-:bvars999999,
		 :avars1-:avars999999
	from auxdata(obs=100);
quit;

%let loopend=&sqlobs;

/* step3 use all of this to throw it back into a series of proc model */
%macro workdone();
	%do i=1 %to &loopend;
		/* one proc per record */
		proc model data=to_forecast_parms outparms=parms_&&ind1_&i.._&&ind2_&i..;
		dif_&term_rate. = &&bvars&i   B9*lag_dif_&term_rate. + gamma*(A0 &&avars&i - lag_&term_rate.) ; 

		fit dif_&term_rate. / dw=1 collin white;
		run;
	%end;
%mend;
		
/* %workdone(); */

%macro workdone2();
	%do i=1 %to &loopend;
		/* one proc per record */
		data _null_;
		file "c:\workdone.txt" MOD;
		put "proc model data=to_forecast_parms outparms=parms_&&ind1_&i.._&&ind2_&i..;";
		put "dif_&term_rate. = &&bvars&i   B9*lag_dif_&term_rate. + gamma*(A0 &&avars&i - lag_&term_rate.) ; ";
		put "fit dif_&term_rate. / dw=1 collin white;";
		put "run;";
		run;
	%end;
%mend;

%workdone2();

